OpenTTD Source: StationViewWindow Struct Reference

OpenTTD Source 14.0-beta1

Data Structures | Public Types | Public Member Functions | Data Fields | Static Public Attributes
StationViewWindow Struct Reference

The StationView window. More...

Inheritance diagram for StationViewWindow:

## Data Structures
struct | RowDisplay
| A row being displayed in the cargo view (as opposed to being "hidden" behind a plus sign). More...

## Public Types
enum | Invalidation { INV_FLOWS = 0x100, INV_CARGO = 0x200 }
| Type of data invalidation. More...
enum | Grouping { GR_SOURCE, GR_NEXT, GR_DESTINATION, GR_CARGO }
| Type of grouping used in each of the "columns". More...
enum | Mode { MODE_WAITING, MODE_PLANNED }
| Display mode of the cargo view. More...
enum | AcceptListHeight { ALH_RATING = 13, ALH_ACCEPTS = 3 }
| Height of the WID_SV_ACCEPT_RATING_LIST widget for different views. More...
typedef std::vector< RowDisplay > | CargoDataVector
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.

## Public Member Functions
| StationViewWindow (WindowDesc *desc, WindowNumber window_number)
void | Close ([[maybe_unused]] int data=0) override
void | ShowCargo (CargoDataEntry *data, CargoID cargo, StationID source, StationID next, StationID dest, uint count)
| Show a certain cargo entry characterized by source/next/dest station, cargo ID and amount of cargo at the right place in the cargo view. More...
void | UpdateWidgetSize (WidgetID widget, Dimension *size, [[maybe_unused]] const Dimension &padding, [[maybe_unused]] Dimension *fill, [[maybe_unused]] Dimension *resize) override
void | OnPaint () override
| The window must be repainted. More...
void | SetStringParameters (WidgetID widget) const override
void | RecalcDestinations (CargoID i)
| Rebuild the cache for estimated destinations which is used to quickly show the "destination" entries even if we actually don't know the destination of a certain packet from just looking at it. More...
void | EstimateDestinations (CargoID cargo, StationID source, StationID next, uint count, CargoDataEntry *dest)
| Estimate the amounts of cargo per final destination for a given cargo, source station and next hop and save the result as children of the given CargoDataEntry. More...
void | BuildFlowList (CargoID i, const FlowStatMap &flows, CargoDataEntry *cargo)
| Build up the cargo view for PLANNED mode and a specific cargo. More...
void | BuildCargoList (CargoID i, const StationCargoList &packets, CargoDataEntry *cargo)
| Build up the cargo view for WAITING mode and a specific cargo. More...
void | BuildCargoList (CargoDataEntry *cargo, const Station *st)
| Build up the cargo view for all cargoes. More...
void | SetDisplayedRow (const CargoDataEntry *data)
| Mark a specific row, characterized by its CargoDataEntry, as expanded. More...
StringID | GetEntryString (StationID station, StringID here, StringID other_station, StringID any)
| Select the correct string for an entry referring to the specified station. More...
StringID | SearchNonStop (CargoDataEntry *cd, StationID station, int column)
| Determine if we need to show the special "non-stop" string. More...
int | DrawEntries (CargoDataEntry *entry, const Rect &r, int pos, int maxrows, int column, CargoID cargo=INVALID_CARGO)
| Draw the given cargo entries in the station GUI. More...
int | DrawAcceptedCargo (const Rect &r) const
| Draw accepted cargo in the WID_SV_ACCEPT_RATING_LIST widget. More...
int | DrawCargoRatings (const Rect &r) const
| Draw cargo ratings in the WID_SV_ACCEPT_RATING_LIST widget. More...
template<class Tid >
void | HandleCargoWaitingClick (CargoDataEntry *filter, Tid next)
| Expand or collapse a specific row. More...
void | HandleCargoWaitingClick (int row)
| Handle a click on a specific row in the cargo view. More...
void | OnClick ([[maybe_unused]] Point pt, WidgetID widget, [[maybe_unused]] int click_count) override
void | SelectSortOrder (SortOrder order)
| Select a new sort order for the cargo view. More...
void | SelectSortBy (int index)
| Select a new sort criterium for the cargo view. More...
void | SelectGroupBy (int index)
| Select a new grouping mode for the cargo view. More...
void | OnDropdownSelect (WidgetID widget, int index) override
void | OnQueryTextFinished (char *str) override
void | OnResize () override
| Called after the window got resized. More...
void | OnInvalidateData ([[maybe_unused]] int data=0, [[maybe_unused]] bool gui_scope=true) override
| Some data on this window has become invalid. More...
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class. More...
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something. More...
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree. More...
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree. More...
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index. More...
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index. More...
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox. More...
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox. More...
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer. More...
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus. More...
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus. More...
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box. More...
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use. More...
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree. More...
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree. More...
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget. More...
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget. More...
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget. More...
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled. More...
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled. More...
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget. More...
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window. More...
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus. More...
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget. More...
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget. More...
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered. More...
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised. More...
void | RaiseWidgetWhenLowered (byte widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered. More...
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget. More...
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus. More...
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget. More...
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget. More...
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget. More...
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks. More...
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in. More...
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window. More...
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets. More...
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets. More...
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered. More...
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e. More...
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol. More...
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner. More...
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size. More...
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded. More...
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing) More...
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized. More...
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window. More...
virtual void | DrawWidget ([[maybe_unused]] const Rect &r, [[maybe_unused]] WidgetID widget) const
| Draw the contents of a nested widget. More...
virtual void | UpdateWidgetSize ([[maybe_unused]] WidgetID widget, [[maybe_unused]] Dimension *size, [[maybe_unused]] const Dimension &padding, [[maybe_unused]] Dimension *fill, [[maybe_unused]] Dimension *resize)
| Update size and resize step of a widget in the window. More...
virtual void | SetStringParameters ([[maybe_unused]] WidgetID widget) const
| Initialize string parameters for a widget. More...
virtual void | OnFocus ()
| The window has gained focus. More...
virtual void | OnFocusLost (bool closing)
| The window has lost focus. More...
virtual EventState | OnKeyPress ([[maybe_unused]] char32_t key, [[maybe_unused]] uint16_t keycode)
| A key has been pressed. More...
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed. More...
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed. More...
virtual void | OnClick ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget, [[maybe_unused]] int click_count)
| A click with the left mouse button has been made on the window. More...
virtual bool | OnRightClick ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| A click with the right mouse button has been made on the window. More...
virtual void | OnHover ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it. More...
virtual bool | OnTooltip ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget, [[maybe_unused]] TooltipCloseCondition close_cond)
| Event to display a custom tooltip. More...
virtual void | OnMouseDrag ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible. More...
virtual void | OnDragDrop ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| A dragged 'object' has been released. More...
virtual void | OnScroll ([[maybe_unused]] Point delta)
| Handle the request for (viewport) scrolling. More...
virtual void | OnMouseOver ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window. More...
virtual void | OnMouseWheel ([[maybe_unused]] int wheel)
| The mouse wheel has been turned. More...
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick ([[maybe_unused]] uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect ([[maybe_unused]] WidgetID widget, [[maybe_unused]] int index)
| A dropdown option associated to this window has been selected. More...
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed. More...
virtual void | OnEditboxChanged ([[maybe_unused]] WidgetID widget)
| The text in an editbox has been edited. More...
virtual void | OnQueryTextFinished ([[maybe_unused]] char *str)
| The query window opened from this window has closed. More...
virtual void | OnPlaceObject ([[maybe_unused]] Point pt, [[maybe_unused]] TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set. More...
virtual bool | OnVehicleSelect ([[maybe_unused]] const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual bool | OnVehicleSelect ([[maybe_unused]] VehicleList::const_iterator begin, [[maybe_unused]] VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag ([[maybe_unused]] ViewportPlaceMethod select_method, [[maybe_unused]] ViewportDragDropSelectionProcess select_proc, [[maybe_unused]] Point pt)
| The user is dragging over the map when the tile highlight mode has been set. More...
virtual void | OnPlaceMouseUp ([[maybe_unused]] ViewportPlaceMethod select_method, [[maybe_unused]] ViewportDragDropSelectionProcess select_proc, [[maybe_unused]] Point pt, [[maybe_unused]] TileIndex start_tile, [[maybe_unused]] TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set. More...
virtual void | OnPlacePresize ([[maybe_unused]] Point pt, [[maybe_unused]] TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode. More...
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable? More...
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window. More...
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Data Fields
uint | expand_shrink_width
| The width allocated to the expand/shrink 'button'.
int | rating_lines
| Number of lines in the cargo ratings view.
int | accepts_lines
| Number of lines in the accepted cargo view.
Scrollbar * | vscroll
CargoSortType | sortings [NUM_COLUMNS]
| Sort types of the different 'columns'. More...
SortOrder | sort_orders [NUM_COLUMNS]
| Sort order (ascending/descending) for the 'columns'.
int | scroll_to_row
| If set, scroll the main viewport to the station pointed to by this row.
int | grouping_index
| Currently selected entry in the grouping drop down.
Mode | current_mode
| Currently selected display mode of cargo view.
Grouping | groupings [NUM_COLUMNS]
| Grouping modes for the different columns.
CargoDataEntry | expanded_rows
| Parent entry of currently expanded rows.
CargoDataEntry | cached_destinations
| Cache for the flows passing through this station.
CargoDataVector | displayed_rows
| Parent entry of currently displayed rows (including collapsed ones).
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position

## Static Public Attributes
static const int | NUM_COLUMNS = 4
| Number of "columns" in the cargo view: cargo, from, via, to.
static const StringID | _sort_names []
| Names of the sorting options in the dropdown. More...
static const StringID | _group_names []
| Names of the grouping options in the dropdown. More...

## Additional Inherited Members
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state. More...
static void | DeleteClosedWindows ()
| Delete all closed windows.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window. More...
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window. More...
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size. More...
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Detailed Description

The StationView window.

Definition at line 1223 of file station_gui.cpp.

## Member Enumeration Documentation

## ◆ AcceptListHeight

enum StationViewWindow::AcceptListHeight

Height of the WID_SV_ACCEPT_RATING_LIST widget for different views.

Enumerator
ALH_RATING | Height of the cargo ratings view.
ALH_ACCEPTS | Height of the accepted cargo view.

Definition at line 1284 of file station_gui.cpp.

## ◆ Grouping

enum StationViewWindow::Grouping

Type of grouping used in each of the "columns".

Enumerator
GR_SOURCE | Group by source of cargo ("from").
GR_NEXT | Group by next station ("via").
GR_DESTINATION | Group by estimated final destination ("to").
GR_CARGO | Group by cargo type.

Definition at line 1263 of file station_gui.cpp.

## ◆ Invalidation

enum StationViewWindow::Invalidation

Type of data invalidation.

Enumerator
INV_FLOWS | The planned flows have been recalculated and everything has to be updated.
INV_CARGO | Some cargo has been added or removed.

Definition at line 1255 of file station_gui.cpp.

## ◆ Mode

enum StationViewWindow::Mode

Display mode of the cargo view.

Enumerator
MODE_WAITING | Show cargo waiting at the station.
MODE_PLANNED | Show cargo planned to pass through the station.

Definition at line 1273 of file station_gui.cpp.

## Member Function Documentation

## ◆ BuildCargoList() [1/2]

void StationViewWindow::BuildCargoList | ( | CargoDataEntry * | cargo,
|  | const Station * | st
| ) |  |
| inline

Build up the cargo view for all cargoes.

Parameters

  cargo | The root cargo entry to save all results in.
  st | The station to calculate the cargo view from.

Definition at line 1642 of file station_gui.cpp.

References BuildCargoList(), BuildFlowList(), GoodsEntry::cargo, GoodsEntry::flows, Station::goods, MODE_WAITING, NUM_CARGO, RecalcDestinations(), and CargoDataEntry::Retrieve().

## ◆ BuildCargoList() [2/2]

void StationViewWindow::BuildCargoList | ( | CargoID | i,
|  | const StationCargoList & | packets,
|  | CargoDataEntry * | cargo
| ) |  |
| inline

Build up the cargo view for WAITING mode and a specific cargo.

Parameters

  i | Cargo to show.
  packets | The current station's cargo list for that cargo.
  cargo | The CargoDataEntry to save the result in.

Definition at line 1595 of file station_gui.cpp.

References CargoPacket::GetFirstStation(), CargoList< Tinst, Tcont >::Packets(), CargoDataEntry::Retrieve(), and ShowCargo().

Referenced by BuildCargoList(), and OnPaint().

## ◆ BuildFlowList()

void StationViewWindow::BuildFlowList | ( | CargoID | i,
|  | const FlowStatMap & | flows,
|  | CargoDataEntry * | cargo
| ) |  |
| inline

Build up the cargo view for PLANNED mode and a specific cargo.

Parameters

  i | Cargo to show.
  flows | The current station's flows for that cargo.
  cargo | The CargoDataEntry to save the results in.

Definition at line 1572 of file station_gui.cpp.

References CargoDataEntry::Begin(), CargoDataEntry::End(), CargoDataEntry::GetCount(), CargoDataEntry::GetStation(), CargoDataEntry::Retrieve(), and ShowCargo().

Referenced by BuildCargoList().

## ◆ DrawAcceptedCargo()

int StationViewWindow::DrawAcceptedCargo | ( | const Rect & | r | ) | const
| inline

Draw accepted cargo in the WID_SV_ACCEPT_RATING_LIST widget.

Parameters

  r | Rectangle of the widget.

Returns
  Number of lines needed for drawing the accepted cargo.

Definition at line 1837 of file station_gui.cpp.

References CeilDiv(), DrawStringMultiLine(), WidgetDimensions::framerect, FS_NORMAL, SpecializedStation< Station, false >::Get(), GetAcceptanceMask(), GetCharacterHeight(), WidgetDimensions::scaled, SetDParam(), and Rect::Shrink().

Referenced by OnPaint().

## ◆ DrawCargoRatings()

int StationViewWindow::DrawCargoRatings | ( | const Rect & | r | ) | const
| inline

Draw cargo ratings in the WID_SV_ACCEPT_RATING_LIST widget.

Parameters

  r | Rectangle of the widget.

Returns
  Number of lines needed for drawing the cargo ratings.

Definition at line 1852 of file station_gui.cpp.

References _current_text_dir, _sorted_standard_cargo_specs, CeilDiv(), DrawString(), DrawStringMultiLine(), Town::exclusive_counter, Town::exclusivity, WidgetDimensions::framerect, FS_NORMAL, SpecializedStation< Station, false >::Get(), GetCharacterHeight(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_link_graph_pool >::GetIfValid(), Station::goods, GoodsEntry::HasRating(), WidgetDimensions::hsep_indent, Rect::Indent(), CargoSpec::Index(), GoodsEntry::link_graph, LinkGraph::Monthly(), CargoSpec::name, GoodsEntry::node, BaseStation::owner, GoodsEntry::rating, WidgetDimensions::scaled, SetDParam(), Rect::Shrink(), TD_RTL, ToPercent8(), BaseStation::town, TimerGameEconomy::UsingWallclockUnits(), and WidgetDimensions::vsep_wide.

Referenced by OnPaint().

## ◆ DrawEntries()

int StationViewWindow::DrawEntries | ( | CargoDataEntry * | entry,
|  | const Rect & | r,
|  | int | pos,
|  | int | maxrows,
|  | int | column,
|  | CargoID | cargo = `INVALID_CARGO`
| ) |  |
| inline

Draw the given cargo entries in the station GUI.

Parameters

  entry | Root entry for all cargo to be drawn.
  r | Screen rectangle to draw into.
  pos | Current row to be drawn to (counted down from 0 to -maxrows, same as vscroll->GetPosition()).
  maxrows | Maximum row to be drawn.
  column | Current "column" being drawn.
  cargo | Current cargo being drawn (if cargo column has been passed).

Returns
  row (in "pos" counting) after the one we have last drawn to.

Definition at line 1753 of file station_gui.cpp.

## ◆ EstimateDestinations()

void StationViewWindow::EstimateDestinations | ( | CargoID | cargo,
|  | StationID | source,
|  | StationID | next,
|  | uint | count,
|  | CargoDataEntry * | dest
| ) |  |
| inline

Estimate the amounts of cargo per final destination for a given cargo, source station and next hop and save the result as children of the given CargoDataEntry.

Parameters

  cargo | ID of the cargo to estimate destinations for.
  source | Source station of the given batch of cargo.
  next | Intermediate hop to start the calculation at ("next hop").
  count | Size of the batch of cargo.
  dest | CargoDataEntry to save the results in.

Definition at line 1519 of file station_gui.cpp.

References GoodsEntry::flows, SpecializedStation< Station, false >::Get(), CargoDataEntry::GetCount(), Station::goods, CargoDataEntry::InsertOrRetrieve(), SpecializedStation< Station, false >::IsValidID(), and CargoDataEntry::Update().

Referenced by RecalcDestinations().

## ◆ GetEntryString()

StringID StationViewWindow::GetEntryString | ( | StationID | station,
|  | StringID | here,
|  | StringID | other_station,
|  | StringID | any
| ) |  |
| inline

Select the correct string for an entry referring to the specified station.

Parameters

  station | Station the entry is showing cargo for.
  here | String to be shown if the entry refers to the same station as this station GUI belongs to.
  other_station | String to be shown if the entry refers to a specific other station.
  any | String to be shown if the entry refers to "any station".

Returns
  One of the three given strings or STR_STATION_VIEW_RESERVED, depending on what station the entry refers to.

Definition at line 1695 of file station_gui.cpp.

## ◆ HandleCargoWaitingClick() [1/2]

template<class Tid >

void StationViewWindow::HandleCargoWaitingClick | ( | CargoDataEntry * | filter,
|  | Tid | next
| ) |  |
| inline

Expand or collapse a specific row.

Parameters

  filter | Parent of the row.
  next | ID pointing to the row.

Definition at line 1888 of file station_gui.cpp.

References CargoDataEntry::InsertOrRetrieve(), CargoDataEntry::Remove(), and CargoDataEntry::Retrieve().

## ◆ HandleCargoWaitingClick() [2/2]

void StationViewWindow::HandleCargoWaitingClick | ( | int | row | ) |
| inline

Handle a click on a specific row in the cargo view.

Parameters

  row | Row being clicked.

Definition at line 1901 of file station_gui.cpp.

References _ctrl_pressed, StationViewWindow::RowDisplay::filter, StationViewWindow::RowDisplay::next_cargo, StationViewWindow::RowDisplay::next_station, Window::SetWidgetDirty(), and WID_SV_WAITING.

## ◆ OnInvalidateData()

void StationViewWindow::OnInvalidateData | ( | [[maybe_unused] ] int | data = `0`,
|  | [[maybe_unused] ] bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Invalidate the cache for the given cargo if necessary.

Parameters

  data | Information about the changed data. If it's a valid cargo ID, invalidate the cargo data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 2108 of file station_gui.cpp.

References NUM_CARGO, Window::ReInit(), and CargoDataEntry::Remove().

## ◆ OnPaint()

void StationViewWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1413 of file station_gui.cpp.

References _local_company, _viewport_highlight_station, Station::airport, AIRPORT_CLOSED_block, BuildCargoList(), DrawAcceptedCargo(), DrawCargoRatings(), Window::DrawSortButtonState(), Window::DrawWidgets(), FACIL_AIRPORT, FACIL_BUS_STOP, FACIL_DOCK, FACIL_NONE, FACIL_TRAIN, FACIL_TRUCK_STOP, BaseStation::facilities, Airport::flags, SpecializedStation< Station, false >::Get(), CargoDataEntry::GetNumChildren(), Window::IsShaded(), BaseStation::owner, OWNER_NONE, Window::ReInit(), Scrollbar::SetCount(), Window::SetWidgetDisabledState(), Window::SetWidgetLoweredState(), WID_SV_ACCEPT_RATING_LIST, WID_SV_ACCEPTS_RATINGS, WID_SV_CATCHMENT, WID_SV_CLOSE_AIRPORT, WID_SV_PLANES, WID_SV_RENAME, WID_SV_ROADVEHS, WID_SV_SHIPS, WID_SV_SORT_ORDER, and WID_SV_TRAINS.

## ◆ OnResize()

void StationViewWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 2098 of file station_gui.cpp.

References WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), and WID_SV_WAITING.

## ◆ RecalcDestinations()

void StationViewWindow::RecalcDestinations | ( | CargoID | i | ) |
| inline

Rebuild the cache for estimated destinations which is used to quickly show the "destination" entries even if we actually don't know the destination of a certain packet from just looking at it.

Parameters

  i | Cargo to recalculate the cache for.

Definition at line 1487 of file station_gui.cpp.

References cached_destinations, CargoDataEntry::Clear(), EstimateDestinations(), GoodsEntry::flows, SpecializedStation< Station, false >::Get(), Station::goods, CargoDataEntry::InsertOrRetrieve(), and CargoDataEntry::Update().

Referenced by BuildCargoList().

## ◆ SearchNonStop()

StringID StationViewWindow::SearchNonStop | ( | CargoDataEntry * | cd,
|  | StationID | station,
|  | int | column
| ) |  |
| inline

Determine if we need to show the special "non-stop" string.

Parameters

  cd | Entry we are going to show.
  station | Station the entry refers to.
  column | The "column" the entry will be shown in.

Returns
  either STR_STATION_VIEW_VIA or STR_STATION_VIEW_NONSTOP.

Definition at line 1716 of file station_gui.cpp.

References CargoDataEntry::Begin(), CargoDataEntry::End(), CargoDataEntry::GetParent(), GR_DESTINATION, and Window::parent.

## ◆ SelectGroupBy()

void StationViewWindow::SelectGroupBy | ( | int | index | ) |
| inline

Select a new grouping mode for the cargo view.

Parameters

  index | Row being selected in the grouping drop down.

Definition at line 2042 of file station_gui.cpp.

References _group_names, _settings_client, GR_DESTINATION, GR_NEXT, GR_SOURCE, ClientSettings::gui, Window::SetDirty(), GUISettings::station_gui_group_order, and WID_SV_GROUP_BY.

## ◆ SelectSortBy()

void StationViewWindow::SelectSortBy | ( | int | index | ) |
| inline

Select a new sort criterium for the cargo view.

Parameters

  index | Row being selected in the sort criteria drop down.

Definition at line 2010 of file station_gui.cpp.

References _settings_client, _sort_names, AsGrouping, Count, ClientSettings::gui, MODE_PLANNED, MODE_WAITING, and GUISettings::station_gui_sort_by.

## ◆ SelectSortOrder()

void StationViewWindow::SelectSortOrder | ( | SortOrder | order | ) |
| inline

Select a new sort order for the cargo view.

Parameters

  order | New sort order.

Definition at line 1999 of file station_gui.cpp.

References _settings_client, ClientSettings::gui, Window::SetDirty(), and GUISettings::station_gui_sort_order.

## ◆ SetDisplayedRow()

void StationViewWindow::SetDisplayedRow | ( | const CargoDataEntry * | data | ) |
| inline

Mark a specific row, characterized by its CargoDataEntry, as expanded.

Parameters

  data | The row to be marked as expanded.

Definition at line 1662 of file station_gui.cpp.

References CargoDataEntry::GetCargo(), CargoDataEntry::GetParent(), CargoDataEntry::GetStation(), Window::parent, and CargoDataEntry::Retrieve().

## ◆ ShowCargo()

void StationViewWindow::ShowCargo | ( | CargoDataEntry * | data,
|  | CargoID | cargo,
|  | StationID | source,
|  | StationID | next,
|  | StationID | dest,
|  | uint | count
| ) |  |
| inline

Show a certain cargo entry characterized by source/next/dest station, cargo ID and amount of cargo at the right place in the cargo view.

I.e. update as many rows as are expanded following that characterization.

Parameters

  data | Root entry of the tree.
  cargo | Cargo ID of the entry to be shown.
  source | Source station of the entry to be shown.
  next | Next station the cargo to be shown will visit.
  dest | Final destination of the cargo to be shown.
  count | Amount of cargo to be shown.

Definition at line 1353 of file station_gui.cpp.

References _settings_game, DT_MANUAL, expanded_rows, GR_CARGO, GR_DESTINATION, GR_NEXT, GR_SOURCE, groupings, CargoDataEntry::InsertOrRetrieve(), GameSettings::linkgraph, NUM_COLUMNS, CargoDataEntry::Retrieve(), CargoDataEntry::SetTransfers(), and CargoDataEntry::Update().

Referenced by BuildCargoList(), and BuildFlowList().

## Field Documentation

## ◆ _group_names

const StringID StationViewWindow::_group_names
| static

Initial value:
= {
STR_STATION_VIEW_GROUP_S_V_D,
STR_STATION_VIEW_GROUP_S_D_V,
STR_STATION_VIEW_GROUP_V_S_D,
STR_STATION_VIEW_GROUP_V_D_S,
STR_STATION_VIEW_GROUP_D_S_V,
STR_STATION_VIEW_GROUP_D_V_S,
INVALID_STRING_ID
}

Names of the grouping options in the dropdown.

Definition at line 1290 of file station_gui.cpp.

Referenced by SelectGroupBy().

## ◆ _sort_names

const StringID StationViewWindow::_sort_names
| static

Initial value:
= {
STR_STATION_VIEW_WAITING_STATION,
STR_STATION_VIEW_WAITING_AMOUNT,
STR_STATION_VIEW_PLANNED_STATION,
STR_STATION_VIEW_PLANNED_AMOUNT,
INVALID_STRING_ID
}

Names of the sorting options in the dropdown.

Definition at line 1289 of file station_gui.cpp.

Referenced by SelectSortBy().

## ◆ sortings

CargoSortType StationViewWindow::sortings[NUM_COLUMNS]

Sort types of the different 'columns'.

In fact only CargoSortType::Count and CargoSortType::AsGrouping are active and you can only sort all the columns in the same way. The other options haven't been included in the GUI due to lack of space.

Definition at line 1298 of file station_gui.cpp.

The documentation for this struct was generated from the following file:

- src/station_gui.cpp

INVALID_STRING_ID
static const StringID INVALID_STRING_ID
Constant representing an invalid string (16bit in case it is used in savegames)
Definition: strings_type.h:17